// C Source File
// Created 6/16/2001; 11:04:46 AM
// James Trimble -- jimmit_t@altavista.com
//
// This is pretty slow. I'm not sure what I can do short of adding ASM to speed this up.
// If you see anything that could make it more efficient, email me.

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

void goMandelbrot ();

// Main Function
void _main(void)
{
	if (!GrayOn ()) return;
  ClearScreen();
	goMandelbrot ();
	ngetchx();
	GrayOff();
}

              
                
void goMandelbrot ()
{       // z = z^2 + c , window is x: -2, .5 and y: -1, 1
        float newz, newzi, z = 0, zi = 0;
        int k = 0, iter = 16;
        float x, y;
        int t, v, w;
        for (x = -2.0; x <= 0.5; x+= 0.015625 )
        {
           for (y = -1.0; y <= 0; y+= 0.02)
           {
                k = 0;
                z = 0;
                zi = 0;
                
                while(k < iter && (z*z)+(zi*zi) < 4)
                {
                 newz = (z*z)-(zi*zi) + x;
                 newzi = 2*z*zi + y;
                 z = newz;
                 zi = newzi;
                 k++;
                }
         			               
                t = (int) ((x+2) * 64);
                v = (int) ((y+1) * 50); 
                w = 150 - (int) ((y+2) * 50); // A mirrored Y-value, I know it's cheap, but its faster.

                if (k == iter)
                {
                	SetPlane(DARK_PLANE);
                	DrawPix(t,v,A_NORMAL);
                	DrawPix(t,w,A_NORMAL);
                }
                else if (k > 9)
                {
                	SetPlane(LIGHT_PLANE);
                	DrawPix(t,v,A_NORMAL);
                	DrawPix(t,w,A_NORMAL);
                }
           }
        }
 }
